capture program drop tab7
program define tab7

#delimit;


scalar define bog=1000;
scalar define dev1=bog;
scalar define dev2=bog;
scalar define dev3=bog;
scalar define dev4=bog;
scalar define bug=1;
matrix define mincut=( 10000 ,20000, 20000 ,10000, 50000);
matrix define maxcut=(10e+10 ,10e+10,50000 ,50000,10e+10);
scalar define numi=colsof(mincut);

/*
log on;
* WAGE INCOME- SLICES BY WAGE INCOME;
log off;
local ii= 1;
while `ii'<numi+1 {

scalar define wmin=mincut[1,`ii'];
scalar define wmax=maxcut[1,`ii'];
scalar define wmin2=wmin/bog;
scalar define wmax2=bog*wmax;

replace wegtt=min(wagr,caph) if wegtt!=1;
regress dlnwag wdmargt mrs1 mrs2 year79-year88  yz79-yz88  lnwag
splwag1-splwag10
(wdmargp mrs1 mrs2 year79-year88  yz79-yz88  lnwag
splwag1-splwag10 ) [w=wegtt]
 if wages/pce>wmin & wages2/pce2>wmin2 & wages/pce<wmax & wages2/pce2<wmax2
& inceff!=. & dmargt!=. & mars==mars2 &
 abs(wdmargp)+abs(wdmargt)<bug & marsi==0, robust cluster(id);
savereg wdmargt;


regress dlnwag wdmargt inceff mrs1 mrs2 year79-year88  yz79-yz88  lnwag
splwag1-splwag10
(wdmargp incefp mrs1 mrs2 year79-year88  yz79-yz88  lnwag
splwag1-splwag10 )
 if wages/pce>wmin & wages2/pce2>wmin2 & wages/pce<wmax & wages2/pce2<wmax2
& inceff!=. & dmargt!=. & mars==mars2 &
 abs(wdmargp)+abs(wdmargt)<bug & marsi==0, robust cluster(id);
savereg wdmargt;savereg inceff;

regress  inceff wdmargp incefp mrs1 mrs2 year79-year88  yz79-yz88  lnwag
splwag1-splwag10
 if wages/pce>wmin & wages2/pce2>wmin2 & wages/pce<wmax & wages2/pce2<wmax2
& inceff!=. & dmargt!=. & mars==mars2 &
 abs(wdmargp)+abs(wdmargt)<bug & marsi==0, robust cluster(id);
savereg incefp;

local ii=`ii'+1;
};

log on;
table2a 1 "Mars   -inflation:num 5   -stat97e,fed0699-
wage income- weights:     -year lag:" 4 numi  "Elast. " "Subst." "Inc. effect"
"First-St" "10K+" "20K+" "20-50K" "10K-50K"
 "50K+";
savereg, clear;
log off;

*/


log on;
* BROAD INCOME-  SLICES BY BROAD INCOME;
log off;


local ii= 1;
while `ii'<numi+1 {

scalar define wmin=mincut[1,`ii'];
scalar define wmax=maxcut[1,`ii'];
scalar define wmin2=wmin/bog;
scalar define wmax2=bog*wmax;

replace wegtt=min(broadnr,caph) if wegtt!=1;
regress dlogbr dmargt  mrs1 mrs2 year79-year88 yz79-yz88 logbr
splbro1-splbro10
(dmargp mrs1 mrs2 year79-year88 yz79-yz88  logbr
splbro1-splbro10 )
if broadn/pce>wmin & broadn2/pce2>wmin2 & broadn/pce<wmax & broadn2/pce2<wmax2
& inceff!=. & dmargt!=. & mars==mars2 &
 abs(dmargp)+abs(dmargt)<bug & marsi==0, robust cluster(id);
savereg dmargt;

regress dlogbr dmargt inceff  mrs1 mrs2 year79-year88 yz79-yz88  logbr
splbro1-splbro10
(dmargp incefp mrs1 mrs2 year79-year88 yz79-yz88  logbr
splbro1-splbro10 )
if broadn/pce>wmin & broadn2/pce2>wmin2 & broadn/pce<wmax & broadn2/pce2<wmax2
& inceff!=. & dmargt!=. & mars==mars2 &
 abs(dmargp)+abs(dmargt)<bug & marsi==0, robust cluster(id);
savereg dmargt;savereg inceff;

regress inceff dmargp incefp  mrs1 mrs2 year79-year88 yz79-yz88  logbr
splbro1-splbro10
if broadn/pce>wmin & broadn2/pce2>wmin2 & broadn/pce<wmax & broadn2/pce2<wmax2
& inceff!=. & dmargt!=. & mars==mars2 &
 abs(dmargp)+abs(dmargt)<bug & marsi==0, robust cluster(id);
savereg incefp;


local ii=`ii'+1;
};

log on;
table2a 1 "Mars   -inflation:num 5   -stat97e,fed0699-
broad income- weights:     -year lag:" 4 numi  "Elast. " "Subst." "Inc. effect"
"First-St" "10K+" "20K+" "20-50K" "10K-50K"
 "50K+";
savereg, clear;
log off;





log on;
* TAXABLE INCOME CONSTANT DEFINITION- SLICES BY BROAD INCOME;
* TAXABLE INCOME SPLINES;
log off;
local ii= 1;
while `ii'<numi+1 {

scalar define wmin=mincut[1,`ii'];
scalar define wmax=maxcut[1,`ii'];
scalar define wmin2=wmin/bog;
scalar define wmax2=bog*wmax;


replace wegtt=min(taxct,caph) if wegtt!=1;
regress dlogtct dmargt  mrs1 mrs2 year79-year88  yz79-yz88  logtct
spltct1-spltct10
(dmargp mrs1 mrs2 year79-year88 yz79-yz88  logtct
spltct1-spltct10 )
if broadn/pce>wmin & broadn2/pce2>wmin2 & broadn/pce<wmax & broadn2/pce2<wmax2
& taxct>10000
& inceff!=. & dmargt!=. & mars==mars2 &
 abs(dmargp)+abs(dmargt)<bug & marsi==0, robust cluster(id);
savereg dmargt;

regress dlogtct  dmargt inceff  mrs1 mrs2 year79-year88 yz79-yz88 logtct
spltct1-spltct10
(dmargp incefp mrs1 mrs2 year79-year88 yz79-yz88  logtct
spltct1-spltct10 )
if broadn/pce>wmin & broadn2/pce2>wmin2 & broadn/pce<wmax & broadn2/pce2<wmax2
& taxct>10000
& inceff!=. & dmargt!=. & mars==mars2 &
 abs(dmargp)+abs(dmargt)<bug & marsi==0, robust cluster(id);
savereg dmargt;savereg inceff;

regress inceff dmargp incefp  mrs1 mrs2 year79-year88 yz79-yz88 logtct
spltct1-spltct10
if broadn/pce>wmin & broadn2/pce2>wmin2 & broadn/pce<wmax & broadn2/pce2<wmax2
& taxct>10000
& inceff!=. & dmargt!=. & mars==mars2 &
 abs(dmargp)+abs(dmargt)<bug & marsi==0, robust cluster(id);
savereg incefp;


local ii=`ii'+1;
};

log on;
table2a 1 "Mars   -inflation:num 5   -stat97e,fed0699-
taxable income (broad slices) - weights:     -year lag:" 4 numi
 "Elast. " "Subst." "Inc. effect" "First-St" "10K+" "20K+" "20-50K" "10K-50K"
 "50K+";
savereg, clear;
log off;

/*
log on;
* PSEUDO-TAXABLE INCOME CONSTANT DEFINITION- SLICES BY BROAD INCOME;
* TAXABLE INCOME SPLINES;
log off;
local ii= 1;
while `ii'<numi+1 {

scalar define wmin=mincut[1,`ii'];
scalar define wmax=maxcut[1,`ii'];
scalar define wmin2=wmin/bog;
scalar define wmax2=bog*wmax;


replace wegtt=min(taxct,caph) if wegtt!=1;
regress dlogtcp dmargt  mrs1 mrs2 year79-year88  yz79-yz88  logtct
spltct1-spltct10
(dmargp mrs1 mrs2 year79-year88 yz79-yz88  logtct
spltct1-spltct10 )
if broadn/pce>wmin & broadn2/pce2>wmin2 & broadn/pce<wmax & broadn2/pce2<wmax2
& taxct>10000
& inceff!=. & dmargt!=. & mars==mars2 &
 abs(dmargp)+abs(dmargt)<bug & marsi==0, robust cluster(id);
savereg dmargt;

regress dlogtcp  dmargt inceff  mrs1 mrs2 year79-year88 yz79-yz88
logtct spltct1-spltct10
(dmargp incefp mrs1 mrs2 year79-year88 yz79-yz88  logtct
spltct1-spltct10 )
if broadn/pce>wmin & broadn2/pce2>wmin2 & broadn/pce<wmax & broadn2/pce2<wmax2
& taxct>10000
& inceff!=. & dmargt!=. & mars==mars2 &
 abs(dmargp)+abs(dmargt)<bug & marsi==0, robust cluster(id);
savereg dmargt;savereg inceff;

regress inceff dmargp incefp  mrs1 mrs2 year79-year88 yz79-yz88
logtct spltct1-spltct10
if broadn/pce>wmin & broadn2/pce2>wmin2 & broadn/pce<wmax & broadn2/pce2<wmax2
& taxct>10000
& inceff!=. & dmargt!=. & mars==mars2 &
 abs(dmargp)+abs(dmargt)<bug & marsi==0, robust cluster(id);
savereg incefp;


local ii=`ii'+1;
};

log on;
table2a 1 "Mars   -inflation:num 5   -stat97e,fed0699-
pseudo-taxable income (broad slices) - weights:     -year lag:" 4 numi
 "Elast. " "Subst." "Inc. effect" "First-St" "10K+" "20K+" "20-50K" "10K-50K" "50K+" ;
savereg, clear;
log off;

*/

end;
