 /* this program creates the Navratil and Felsdtein
data set from d3tall (all variables are kept) */

* OPTIONS errors=100;

libname bobo '/scratch/saez';


DATA bobo.navratil;
set bobo.d3tall;

IF flpdyr=80;

loss=max(0,partl-party)+
max(0,sbtlss-sbtly)+max(0,estlss-esty)+max(0,-rentyl)+max(0,-ryltyl);
taxinc=newtxy-cgdist-cgagi+secern+keogh+iraded+loss;
loss2=max(0,partl2-party2)+
max(0,sbtlss2-sbtly2)+max(0,estlss2-esty2)+max(0,-rentyl2)+max(0,-ryltyl2);
taxinc2=newtxy2-cgdist2-cgagi2+secern2+keogh2+iraded2+loss2;

RUN;


DATA bobo.feldst;
set bobo.d3tall;
IF flpdyr=85;


loss=max(0,-frent)+
max(0,-rentyl)+max(0,-ryltyl)+sbtlss+estlss+partl;
taxinc=agi-cgdist-cgagi+secern+loss;
taxinc=(pce2/pce)*taxinc-xtot*1950-max(totald*pce2/pce,5000);

loss2=max(0,-frent2)+
max(0,-rentyl2)+max(0,-ryltyl2)+estlss2+passl2+
npassl2+smbloss2+sbnpls2;
taxinc2=newtxy2-cgdist2-cgagi2+loss2;


fagi=agi+secern+1.5*(cgagi+cgdist);
fagi=pce2*fagi/pce;
cagi=agi-cgdist-cgagi+secern;
cagi=pce2*cagi/pce;
taxic=cagi-xtot*1950-max(totald*pce2/pce,5000);
fagi2=agi2;
cagi2=agi2-cgdist2-cgagi2;
taxic2=newtxy2-cgdist2-cgagi2;


RUN;


libname old '/scratch/saez';
libname trans XPORT '/scratch/saez/navratil';
proc copy in=old out=trans;
select navratil;
run;

libname old '/scratch/saez';
libname trans XPORT '/scratch/saez/feldst';
proc copy in=old out=trans;
select feldst;
run;


