capture program drop tab5
program define tab5

#delimit;



scalar define bog=1000;
scalar define dev1=bog;
scalar define dev2=bog;
scalar define dev3=bog;
scalar define dev4=bog;
scalar define bug=1;
matrix define mincut=(10000);
matrix define maxcut=(10e+10);
scalar define numi=colsof(mincut);
local ii= 1;
while `ii'<numi+1 {

scalar define wmin=mincut[1,`ii'];
scalar define wmax=maxcut[1,`ii'];
scalar define wmin2=wmin/bog;
scalar define wmax2=bog*wmax;



replace wegtt=min(broadnr,caph) if wegtt!=1;
regress dlogbr fdmargt sdmargt  mrs1 mrs2 year79-year88 yz79-yz88
logbr splbro1-splbro10 logbrav (fdmargp sdmargp mrs1 mrs2 year79-year88
yz79-yz88  logbr splbro1-splbro10 logbrav)  [w=wegtt]
if broadn/pce>wmin & broadn2/pce2>wmin2 & broadn/pce<wmax & broadn2/pce2<wmax2
& inceff!=. & dmargt!=. & mars==mars2 &
 abs(dmargp)+abs(dmargt)<bug & marsi==0, robust cluster(id);
savereg  fdmargt;savereg  sdmargt;

replace wegtt=min(taxct,caph) if wegtt!=1;
regress dlogtct fdmargt sdmargt  mrs1 mrs2 year79-year88  yzt79-yzt88   logtct
spltct1-spltct10 logtavt
(fdmargp sdmargp  mrs1 mrs2 year79-year88  yzt79-yzt88  logtct
spltct1-spltct10 logtavt)  [w=wegtt]
if broadn/pce>wmin & broadn2/pce2>wmin2 & broadn/pce<wmax & broadn2/pce2<wmax2
& taxct>0
& inceff!=. & dmargt!=. & mars==mars2 &
 abs(dmargp)+abs(dmargt)<bug & marsi==0, robust cluster(id);
savereg  fdmargt;savereg  sdmargt;

replace wegtt=min(taxct,caph) if wegtt!=1;
regress dlogtcp  fdmargt sdmargt  mrs1 mrs2 year79-year88  yzt79-yzt88   logtct
spltct1-spltct10  logtavt
( fdmargp sdmargp mrs1 mrs2 year79-year88  yzt79-yzt88  logtct
spltct1-spltct10  logtavt )  [w=wegtt]
if broadn/pce>wmin & broadn2/pce2>wmin2 & broadn/pce<wmax & broadn2/pce2<wmax2
& taxct>0
& inceff!=. & dmargt!=. & mars==mars2 &
 abs(dmargp)+abs(dmargt)<bug & marsi==0, robust cluster(id);
savereg  fdmargt;savereg  sdmargt;

replace wegtt=min(taxcs,caph) if wegtt!=1;
regress dlogtcs  fdmargt sdmargt  mrs1 mrs2 year79-year88  yzt79-yzt88
logtcs spltct1-spltct10  logtavs
( fdmargp sdmargp mrs1 mrs2 year79-year88  yzt79-yzt88  logtcs
spltct1-spltct10  logtavs)  [w=wegtt]
if broadn/pce>wmin & broadn2/pce2>wmin2 & broadn/pce<wmax & broadn2/pce2<wmax2
& taxct>0
& inceff!=. & dmargt!=. & mars==mars2 &
 abs(dmargp)+abs(dmargt)<bug & marsi==0, robust cluster(id);
savereg  fdmargt;savereg  sdmargt;

replace wegtt=min(taxcc,caph) if wegtt!=1;
regress dlogtcc  fdmargt sdmargt  mrs1 mrs2 year79-year88  yzt79-yzt88
logtcc spltct1-spltct10  logtavc
( fdmargp sdmargp mrs1 mrs2 year79-year88  yzt79-yzt88  logtcc
spltct1-spltct10  logtavc)  [w=wegtt]
if broadn/pce>wmin & broadn2/pce2>wmin2 & broadn/pce<wmax & broadn2/pce2<wmax2
& taxct>0
& inceff!=. & dmargt!=. & mars==mars2 &
 abs(dmargp)+abs(dmargt)<bug & marsi==0, robust cluster(id);
savereg  fdmargt;savereg  sdmargt;

replace wegtt=min(taxcm,caph) if wegtt!=1;
regress dlogtcm  fdmargt sdmargt  mrs1 mrs2 year79-year88  yzt79-yzt88
logtcm spltct1-spltct10  logtavm
( fdmargp sdmargp mrs1 mrs2 year79-year88  yzt79-yzt88  logtcm
spltct1-spltct10  logtavm)  [w=wegtt]
if broadn/pce>wmin & broadn2/pce2>wmin2 & broadn/pce<wmax & broadn2/pce2<wmax2
& taxct>0
& inceff!=. & dmargt!=. & mars==mars2 &
 abs(dmargp)+abs(dmargt)<bug & marsi==0, robust cluster(id);
savereg  fdmargt;savereg sdmargt;


local ii=`ii'+1;
};

log on;
table2a 1 "Mars    -inflat.:num 7 -stat97e,fed0699-
 - weights:     -year lag:" 2 6 "Fed rate" "state rate" "Broad"
"Taxable" "Pseudo" "tax+state" "+contr" "+mort";
savereg, clear;
log off;

end;
